import { message, Checkbox, Radio } from "antd/lib/index";
import { getPropertyData, guid, extendInclude, extendRule, getDataFieldValue, setDataFieldValue, initFilter, empty, onBeforeSaveHandleRecordLog, Format } from "../../utils/common";
import { connect } from 'dva';
import moment from 'moment';
import config from "../../config.js"
import { Button, Row, Col, Form, Input, Select, Upload, Icon, Modal, Spin } from 'antd';
import storage from '../../utils/storage'

/**
 * @return {string}
 */
// 编辑  事故事件调查结果填报
export default {
  onBeforeSaveHandleRecord(params) {
    params.record.TaskID = params.data.TaskID    //TaskID传递消息表ID
    params.record.STATUS = params.customParams;
    onBeforeSaveHandleRecordLog(params, 'AE010', '事故事件调查结果填报前端日志')
  },
  onBeforeEdit(params) {
    const { stateData } = params ? params : {};
    if (stateData.Nav_ListForensics != null && stateData.Nav_ListForensics.length > 0) {
      // 字表重写
      let details = [];
      stateData.Nav_ListForensics.forEach(t => {
        let detail = {
          Files: [],
          Nav_FilesSurvey: t.Nav_FilesSurvey,
          ID: t.ID,

          // MONEY_ID: t.MONEY_ID,
          // NAME: t.NAME,
          // TOTAL: t.TOTAL,
          // USE: t.USE,
          EVIDENCE_SOURCE: t.EVIDENCE_SOURCE,
          EVIDENCE_DESC: t.EVIDENCE_DESC,

          ROW_NO: t.ROW_NO,
          ENTITY_ORG_TPYE: t.ENTITY_ORG_TPYE,
          ORG_ID: t.ORG_ID,
          CREATE_TIME: t.CREATE_TIME,
          IS_DELETED: t.IS_DELETED
        }
        if (t.Nav_FilesSurvey) {
          t.Nav_FilesSurvey.forEach(x => {
            //附件信息赋值给数据库对象，多个附件需要遍历附件信息
            detail.Files.push({
              uid: x.ID,
              name: x.name ? x.name : (x.Nav_ImgFile ? x.Nav_ImgFile.FILE_NAME : '未知文件'),
              status: x.status ? x.status : 'done',
              response: { Data: { imgFileID: x.IMG_FILE_ID }, file: x },
              url: x.Nav_ImgFile ? (config.picServerHost + x.Nav_ImgFile.Nav_File.FILE_PATH) : '',
            })
          })
        }
        details.push(detail);
      });
      details = details.map((item, i) => {
        return item;
      });
      stateData.Nav_ListForensics = details;
    }

    params['record'] = stateData;
  },
  handleRenderRowControl(params) {
    if (params.colConfig.field === 'Nav_FilesSurvey') {
      const Tenant = storage('lacal').getItem('Tenant').val;
      const that = this;
      const uploadSopProps = {
        name: 'file',
        action: config.serviceHost('api/PF/File/UploadFile'),
        data: { OrgId: params.login.OrgId },
        fileList: params.record['Files'],
        headers: {
          Tenant: Tenant,
        },
        onChange(info) {
          params.record['Files'] = [...info.fileList];
          // params.saveRowRecord(params.record);
          if (info.file.status !== 'uploading') {

          }
          if (info.file.status === 'removed') {
            if (info.file.response && info.file.response.file) {
              info.file.response.file.IS_DELETED = true;
            }
          }
          if (info.file.status === 'done') {
            let uploadFiles = [...info.fileList]
            if (uploadFiles) {
              let navFiles = [];
              uploadFiles.forEach(t => {
                if (t.response) {
                  //附件信息赋值给数据库对象，多个附件需要遍历附件信息
                  navFiles.push({
                    IMG_FILE_ID: t.response.Data.imgFileID,   //附件表文件名称
                    ID: t.response.file ? t.uid : guid()//标记ID
                  })
                }
              });
              params.record['Nav_FilesSurvey'] = navFiles;
            }
            message.success(`${info.file.name} 上传成功`);
          } else if (info.file.status === 'error') {
            message.error(`${info.file.name} 上传失败！`);
          }
          params.saveRowRecord(params.record);
        },
      };
      return <>
        <Upload {...uploadSopProps}>
          <Button>
            <Icon type="upload" /> 上传附件
          </Button>
        </Upload>
      </>
    }
  },
}
